//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

extern int  price         = PRICE_CLOSE;
extern bool useTotalTicks = false;

//
//
//
//
//

double bufferhu[];
double bufferhd[];
double bufferu[];
double bufferd[];
double bufferdu[];
double bufferdd[];
double buffertu[];
double buffertd[];
bool sameSide = true;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   IndicatorDigits(6);
   SetIndexBuffer(0,bufferhu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bufferhd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferu);  
   SetIndexBuffer(3,bufferd);  
   SetIndexBuffer(4,bufferdu); SetIndexEmptyValue(2,0);
   SetIndexBuffer(5,bufferdd); SetIndexEmptyValue(3,0);
   SetIndexBuffer(6,buffertu); SetIndexEmptyValue(4,0);
   SetIndexBuffer(7,buffertd); SetIndexEmptyValue(5,0);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   static double previousTick = 0;
      if (previousTick==0) 
      {
         previousTick = iMA(NULL,0,1,0,MODE_SMA,price,0);
         return(0);
      }

      //
      //
      //
      //
      //
      
      double mull = 1; if (sameSide) mull = -1;      
      double diff = iMA(NULL,0,1,0,MODE_SMA,price,0)-previousTick;
         if (diff>0) { bufferdu[0] += diff;      buffertu[0] += 1; }
         if (diff<0) { bufferdd[0] += diff*mull; buffertd[0] += 1; }
         double ticksu = buffertu[0]; if (useTotalTicks) ticksu += buffertd[0];
         double ticksd = buffertd[0]; if (useTotalTicks) ticksd += buffertu[0];
         if (ticksu != 0) 
               bufferu[0] = bufferdu[0]/ticksu;
         else  bufferu[0] = 0;
         if (ticksd != 0) 
               bufferd[0] = bufferdd[0]/ticksd;
         else  bufferd[0] = 0;
         previousTick = iMA(NULL,0,1,0,MODE_SMA,price,0);
         bufferhu[0] = bufferhu[0];
         bufferhd[0] = bufferhd[0];
         if (bufferu[0]>bufferd[0]) { bufferhu[0] = 1; bufferhd[0] = EMPTY_VALUE; }
         if (bufferu[0]<bufferd[0]) { bufferhd[0] = 1; bufferhu[0] = EMPTY_VALUE; }
   return(0);
}

